Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.mule.transport.jdbc
Class JdbcMessageReceiver

    java.lang.Object
      org.mule.transport.AbstractTransportMessageHandler
          org.mule.transport.AbstractMessageReceiver
              org.mule.transport.AbstractPollingMessageReceiver
                  org.mule.transport.TransactedPollingMessageReceiver
                      org.mule.transport.jdbc.JdbcMessageReceiver

All Implemented Interfaces:
  Disposable, Initialisable, Lifecycle, LifecycleStateEnabled, Startable, Stoppable, MessageSource, Connectable, MessageReceiver

    public class JdbcMessageReceiver

extends TransactedPollingMessageReceiver

Implements `TransactedPollingMessageReceiver` reading data from a database. Provides a way to acknowledge each read data using a SQL statement.

Nested Class Summary

Nested classes/interfaces inherited from class org.mule.transport.TransactedPollingMessageReceiver
`TransactedPollingMessageReceiver.MessageProcessorWorker`

Field Summary
`protected List` | `ackParams`
`protected String` | `ackStmt`
`protected JdbcConnector` | `connector`
`protected List` | `readParams`
`protected String` | `readStmt`
`static String` | `RECEIVE_MESSAGE_IN_TRANSCTION`
`static String` | `RECEIVE_MESSAGES_IN_XA_TRANSCTION`
`boolean` | `receiveMessagesInXaTransaction`

Fields inherited from class org.mule.transport.AbstractPollingMessageReceiver
`DEFAULT_POLL_FREQUENCY, DEFAULT_POLL_TIMEUNIT, DEFAULT_STARTUP_DELAY, schedules`

Fields inherited from class org.mule.transport.AbstractMessageReceiver
`defaultInboundTransformers, defaultResponseTransformers, flowConstruct, listener, receiverKey`

Fields inherited from class org.mule.transport.AbstractTransportMessageHandler
`connected, connecting, endpoint, lifecycleManager, logger, muleMessageFactory, retryTemplate, startOnConnect`

Fields inherited from interface org.mule.api.lifecycle.Initialisable
`PHASE_NAME`

Fields inherited from interface org.mule.api.lifecycle.Startable
`PHASE_NAME`

Fields inherited from interface org.mule.api.lifecycle.Stoppable
`PHASE_NAME`

Fields inherited from interface org.mule.api.lifecycle.Disposable
`PHASE_NAME`

Constructor Summary
`JdbcMessageReceiver(Connector connector, FlowConstruct flowConstruct, InboundEndpoint endpoint, String readStmt, String ackStmt)`

Method Summary
`protected List<MuleMessage>` | `createMuleMessages(List<Object> records)` Creates a mule message per each data record.
`protected void` | `doConnect()`
`protected void` | `doDisconnect()`
`protected void` | `doDispose()`
`protected int` | `executeAckStatement(Connection con, MuleMessage muleMessage)` Executes the acknowledge SQL statement for a given message.
`protected int[]` | `executeBatchAckStatement(Connection con, List<MuleMessage> messages)` Executes the acknowledge SQL statement for a list of messages.
`protected List` | `executeReadStatement(Connection con)` Executes the read SQL statement to get data from the database.
`List` | `getMessages()`
`protected boolean` | `hasAckStatement()`
`protected void` | `parseStatements(String readStmt, String ackStmt)` Parses the read and acknowledge SQL statements
`void` | `processMessage(Object message)`

Methods inherited from class org.mule.transport.TransactedPollingMessageReceiver
`doStart, isReceiveMessagesInTransaction, isUseMultipleTransactedReceivers, poll, setReceiveMessagesInTransaction, setUseMultipleTransactedReceivers`

Methods inherited from class org.mule.transport.AbstractPollingMessageReceiver
`createWork, disableNativeScheduling, doStop, getFrequency, getTimeUnit, schedule, setFrequency, setTimeUnit, unschedule`

Methods inherited from class org.mule.transport.AbstractMessageReceiver
`applyInboundTransformers, applyResponseTransformers, createLifecycleManager, createMuleEvent, getConnectEventId, getConnectionDescription, getEndpoint, getEndpointURI, getFlowConstruct, getReceiverKey, getWorkManager, handleUnacceptedFilter, initialise, routeMessage, routeMessage, routeMessage, routeMessage, setEndpoint, setListener, setReceiverKey, toString`

Methods inherited from class org.mule.transport.AbstractTransportMessageHandler
`activate, callDoStartWhenItIsConnected, connect, connectAndThenStart, createMuleMessage, createMuleMessage, createMuleMessage, createMuleMessageFactory, createNullMuleMessage, disconnect, dispose, disposeAndLogException, doInitialise, getConnectEventId, getConnector, getLifecycleState, initializeMessageFactory, initializeRetryPolicy, isConnected, isConnecting, isDoStartMustFollowDoConnect, isDoThreading, isStarted, passivate, setEndpoint, start, stop, validate, validateConnection`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.mule.api.transport.MessageReceiver
`createMuleMessage, createMuleMessage`

Methods inherited from interface org.mule.api.transport.Connectable
`connect, disconnect, isConnected, validateConnection`

Methods inherited from interface org.mule.api.lifecycle.Startable
`start`

Methods inherited from interface org.mule.api.lifecycle.Stoppable
`stop`

Methods inherited from interface org.mule.api.lifecycle.Disposable
`dispose`

Field Detail

### RECEIVE_MESSAGE_IN_TRANSCTION

    public static final String RECEIVE_MESSAGE_IN_TRANSCTION

See Also:
  Constant Field Values

### RECEIVE_MESSAGES_IN_XA_TRANSCTION

    public static final String RECEIVE_MESSAGES_IN_XA_TRANSCTION

See Also:
  Constant Field Values

### connector

    protected JdbcConnector connector

### readStmt

    protected String readStmt

### ackStmt

    protected String ackStmt

### readParams

    protected List readParams

### ackParams

    protected List ackParams

### receiveMessagesInXaTransaction

    public boolean receiveMessagesInXaTransaction

Constructor Detail

### JdbcMessageReceiver

    public JdbcMessageReceiver(Connector connector,
                               FlowConstruct flowConstruct,
                               InboundEndpoint endpoint,
                               String readStmt,
                               String ackStmt)
                        throws CreateException

Throws:
  `CreateException`

Method Detail

### parseStatements

    protected void parseStatements(String readStmt,
                                   String ackStmt)

  Parses the read and acknowledge SQL statements

### doDispose

    protected void doDispose()

  Overrides:
    `doDispose` in class `AbstractMessageReceiver`

### doConnect

    protected void doConnect()
                      throws Exception

  Overrides:
    `doConnect` in class `AbstractTransportMessageHandler`
  Throws:
    `Exception`

### doDisconnect

    protected void doDisconnect()
                         throws Exception

  Overrides:
    `doDisconnect` in class `AbstractTransportMessageHandler`
  Throws:
    `Exception`

### processMessage

    public void processMessage(Object message)
                        throws Exception

  Specified by:
    `processMessage` in class `TransactedPollingMessageReceiver`
  Throws:
    `Exception`

### hasAckStatement

    protected boolean hasAckStatement()

### createMuleMessages

    protected List<MuleMessage> createMuleMessages(List<Object> records)

  Creates a mule message per each data record.

  Parameters:
    `records` - data records used to created the payload of the new messages.
  Returns:
    the created messages

### executeAckStatement

    protected int executeAckStatement(Connection con,
                                      MuleMessage muleMessage)
                               throws Exception

  Executes the acknowledge SQL statement for a given message.

  Parameters:
    `con` - database connection to execute the statement
    `muleMessage` - message to been acknowledge
  Returns:
    the number of updated rows by the SQL statement
  Throws:
    `Exception`

### executeBatchAckStatement

    protected int[] executeBatchAckStatement(Connection con,
                                             List<MuleMessage> messages)
                                      throws Exception

  Executes the acknowledge SQL statement for a list of messages.

  Parameters:
    `con` - database connection to execute the statement
    `messages` - messages to be acknowledge
  Returns:
    the number of updated rows by each batched execution
  Throws:
    `Exception`

### getMessages

    public List getMessages()
                     throws Exception

  Specified by:
    `getMessages` in class `TransactedPollingMessageReceiver`
  Throws:
    `Exception`

### executeReadStatement

    protected List executeReadStatement(Connection con)
                                 throws Exception

  Executes the read SQL statement to get data from the database.

  Parameters:
    `con` - database connection to execute the statement
  Returns:
    the list of read records
  Throws:
    `Exception`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2010 MuleSoft, Inc.. All Rights Reserved.